"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactMotion = require("react-motion");

var _scrollTo = require("scroll-to");

var _scrollTo2 = _interopRequireDefault(_scrollTo);

var _tourButton = require("./tour-button");

var _tourButton2 = _interopRequireDefault(_tourButton);

var _tourButtonContainer = require("./tour-button-container");

var _tourButtonContainer2 = _interopRequireDefault(_tourButtonContainer);

var _arrow = require("./arrow");

var _arrow2 = _interopRequireDefault(_arrow);

var _positionHelpers = require("./position-helpers");

var _positionHelpers2 = _interopRequireDefault(_positionHelpers);

var ReactUserTour = (function (_Component) {
	_inherits(ReactUserTour, _Component);

	function ReactUserTour(props) {
		_classCallCheck(this, ReactUserTour);

		_get(Object.getPrototypeOf(ReactUserTour.prototype), "constructor", this).call(this, props);
		this.prevPos = {
			top: 0,
			left: 0
		};
		this.getStepPosition = this.getStepPosition.bind(this);
	}

	_createClass(ReactUserTour, [{
		key: "shouldComponentUpdate",
		value: function shouldComponentUpdate(nextProps) {
			return this.props.step !== nextProps.step || this.props.active !== nextProps.active;
		}
	}, {
		key: "getStepPosition",
		value: function getStepPosition(selector, tourElWidth, tourElHeight, overridePos) {
			var windowHeight = window.innerHeight;
			var windowWidth = window.innerWidth;
			var el = document.querySelector(selector);
			if (el) {
				var position = el ? el.getBoundingClientRect() : {};
				var isElementCompletelyBelowViewBox = windowHeight - position.top < 0;
				var isElementCompletelyAboveViewBox = position.bottom < 0;
				if (isElementCompletelyBelowViewBox) {
					(0, _scrollTo2["default"])(0, position.bottom, {
						ease: "out-sine",
						duration: 500
					});
					position = el.getBoundingClientRect();
				} else if (isElementCompletelyAboveViewBox) {
					(0, _scrollTo2["default"])(0, window.pageYOffset + position.top, {
						ease: "out-sine",
						duration: 500
					});
					position = el.getBoundingClientRect();
				}
				var shouldPositionLeft = windowWidth - position.left < windowWidth / 2;
				var shouldPositionAbove = windowHeight - position.bottom < 100;
				var shouldPositionBelow = position.top < 50;
				var elPos = undefined;
				if (overridePos && _positionHelpers2["default"][overridePos]) {
					elPos = _positionHelpers2["default"][overridePos]({
						position: position,
						tourElWidth: tourElWidth,
						tourElHeight: tourElHeight,
						arrowSize: this.props.arrowSize,
						offsetHeight: el.offsetHeight
					});
				} else if (shouldPositionLeft && !shouldPositionAbove && !shouldPositionBelow) {
					elPos = _positionHelpers2["default"].left({ position: position, tourElWidth: tourElWidth });
				} else if (shouldPositionAbove) {
					elPos = shouldPositionLeft ? _positionHelpers2["default"].topLeft({
						position: position,
						tourElWidth: tourElWidth,
						tourElHeight: tourElHeight,
						arrowSize: this.props.arrowSize
					}) : _positionHelpers2["default"].top({
						position: position,
						tourElHeight: tourElHeight,
						arrowSize: this.props.arrowSize
					});
				} else if (shouldPositionBelow) {
					elPos = shouldPositionLeft ? _positionHelpers2["default"].bottomLeft({
						position: position,
						tourElWidth: tourElWidth,
						arrowSize: this.props.arrowSize,
						offsetHeight: el.offsetHeight
					}) : _positionHelpers2["default"].bottom({
						position: position,
						arrowSize: this.props.arrowSize,
						offsetHeight: el.offsetHeight
					});
				} else {
					elPos = _positionHelpers2["default"].right({ position: position });
				}
				this.prevPos = elPos;
				return elPos;
			} else {
				return this.prevPos;
			}
		}
	}, {
		key: "render",
		value: function render() {
			var _this = this;

			var currentTourStep = this.props.steps.filter(function (step) {
				return step.step === _this.props.step;
			})[0];
			if (!this.props.active || !currentTourStep) {
				return _react2["default"].createElement("span", null);
			}
			var position = this.getStepPosition(currentTourStep.selector, this.props.style.width, this.props.style.height, currentTourStep.position);
			var style = _extends({}, this.props.style);
			var arrow = this.props.arrow || _react2["default"].createElement(_arrow2["default"], {
				position: position.positioned,
				width: this.props.style.width,
				height: this.props.style.height,
				size: this.props.arrowSize,
				color: this.props.arrowColor
			});

			var extraButtonProps = this.props.buttonStyle ? { style: this.props.buttonStyle } : {};

			var nextButton = this.props.step !== this.props.steps.length ? _react2["default"].createElement(
				_tourButton2["default"],
				_extends({
					onClick: function () {
						return _this.props.onNext(_this.props.step + 1);
					}
				}, extraButtonProps, {
					className: "react-user-tour-next-button" }),
				this.props.nextButtonText
			) : "";

			var backButton = this.props.step !== 1 ? _react2["default"].createElement(
				_tourButton2["default"],
				_extends({
					onClick: function () {
						return _this.props.onBack(_this.props.step - 1);
					}
				}, extraButtonProps, {
					className: "react-user-tour-back-button" }),
				this.props.backButtonText
			) : "";

			var doneButton = this.props.step === this.props.steps.length ? _react2["default"].createElement(
				_tourButton2["default"],
				_extends({
					onClick: function () {
						return _this.props.onCancel();
					}
				}, extraButtonProps, {
					className: "react-user-tour-done-button" }),
				this.props.doneButtonText
			) : "";

			var tourButtonContainer = !this.props.hideButtons ? _react2["default"].createElement(
				_tourButtonContainer2["default"],
				{ style: this.props.buttonContainerStyle },
				nextButton,
				doneButton,
				backButton
			) : "";

			var xStyle = {
				"float": "right",
				"cursor": "pointer",
				"paddingRight": 10,
				"paddingTop": 10
			};

			var closeButton = !this.props.hideClose ? _react2["default"].createElement(
				"span",
				{ className: "react-user-tour-close",
					style: xStyle,
					onClick: this.props.onCancel },
				"Close"
			) : "";

			return _react2["default"].createElement(
				"div",
				{ className: "react-user-tour-container" },
				_react2["default"].createElement(
					_reactMotion.Motion,
					{ style: { x: (0, _reactMotion.spring)(position.left), y: (0, _reactMotion.spring)(position.top) } },
					function (_ref) {
						var x = _ref.x;
						var y = _ref.y;
						return _react2["default"].createElement(
							"div",
							{ style: _extends({}, style, { transform: "translate3d(" + x + "px, " + y + "px, 0)" }) },
							arrow,
							closeButton,
							currentTourStep.title,
							currentTourStep.body,
							tourButtonContainer
						);
					}
				)
			);
		}
	}]);

	return ReactUserTour;
})(_react.Component);

exports["default"] = ReactUserTour;

ReactUserTour.defaultProps = {
	style: {
		height: 150,
		width: 350,
		position: "absolute",
		zIndex: 9999,
		backgroundColor: "#fff",
		color: "#494949",
		boxShadow: "0 6px 8px 0 rgba(0, 0, 0, 0.24)"
	},
	onCancel: function onCancel() {},
	onNext: function onNext() {},
	onBack: function onBack() {},
	nextButtonText: "Next",
	backButtonText: "Back",
	doneButtonText: "Done",
	buttonContainerStyle: {
		position: "absolute",
		bottom: 10,
		right: 0
	},
	hideButtons: false,
	hideClose: false,
	arrowColor: "#fff",
	arrowSize: 15
};
module.exports = exports["default"];